/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is YellowMapBar for Mozilla.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var DEBUG_USE_DUMPS = true ; // Enable to see our dumps, eventually all will use something like this?
var altAction, altCtrlAction, altShiftAction, ctrlAction, ctrlShiftAction, noneAction, shiftAction;
var altLocation, altCtrlLocation, altShiftLocation, ctrlLocation, ctrlShiftLocation, noneLocation, shiftLocation;

var boolCritSelected, ymb_loaded, win, hkeytgl, yellowmapbarRemoveNow;
var boolCritSelected = ymb_loaded = win = hkeytgl = srch4SelAppnd = yellowmapbarRemoveNow = false;
var openerUpdated = false;

var critIgnoreFocus = false;
var critIgnoreClick = false;
var ignoreUpDir = false;

var n = 0;
var term = '';

var inFirebird = false ; // Are we in Firebird, or Mozilla.

var arrDeckActs = [
  "default", "Poi", "CityGuide" 
];

var arrDeckLocs = [
  "Same Window", "New Tab", "New Window"
];

var cntrySfxs = new Array(99);
var ymbLocaleCountry, ymbcntry2SrchIx;

// the option flags that we are going to save search history across browser sessions
var autoSearchOption = false;
var historyOption = true;
var historyLoaded = false;
var maxHistCnt;
var ymbMaxMyLocationsCount = 10;
var sep = "||";

var saveLastOption = false;
var hideMenuOption = false;
var queryStringOption = false;

var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);

var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);

var pref = prefService.getBranch(null); // preferences root node, is it used? JW.
var prefRoot = prefService.getBranch(null); // preferences root node
var ymbPref = prefService.getBranch("yellowmapbar."); // preferences yellowmapbar node

// Search component
var ymbFinder = Components.classes["@mozilla.org/embedcomp/rangefind;1"].createInstance()
                        .QueryInterface(Components.interfaces.nsIFind);

var stdUrl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance();
stdUrl = stdUrl.QueryInterface(Components.interfaces.nsIURL);

// DOMRange used during highlighting
var searchRange;
var startPt;
var endPt;

// Is the highlight active ?
var ymbHighlightOn = false;

// What was the term used for the highlighting ?
var gHighlightString = "";

// Save selection during highlighting
var gSelection = null;
var gSaveSelection = null;

// Colors for highlighting
var termColor = new Array("yellow", "lightpink", "aquamarine", "darkgoldenrod", "darkseagreen", "lightgreen", "rosybrown", "seagreen", "chocolate", "violet");

// Remember the last focused element for stateful toggling
var gStatefulPrevFocus = null;

// Array for storing last YellowMap search results
// (used by back/fwd result navigation stuff)
var lastResults = new Array(0);
var lastYellowMap = null;

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// Init //////////////////////////////////////

function yellowmapbarDisplayCheck()
{
    // make sure that we are loading the preferences
    yellowmapbarInitPrefs();

    if (!historyLoaded) {
        historyLoaded = true;

        if (historyOption) {
            yellowmapbarInitHistory();
        }
        else {
            ymbPref.setCharPref("history", "");
        }

		yellowmapbarInitMyLocations();
    }

    if (ymbHighlightOn) {
        setTimeout("yellowmapbarRefreshHighlight()", 100);
    }

    yellowmapbarUpdateCriteriaDropmarker();
}

function yellowmapbarUpdateCriteriaDropmarker(prefValue)
{
    var mainDoc = document;
    var critMenu = mainDoc.getElementById("yellowmapbarCriteria");

    /* XXX When there is no opener?
    If were are in the preferences then we need to update the document, and get the preference value */
    if (!critMenu) {
        mainDoc = top.opener.document;
        critMenu = mainDoc.getElementById("yellowmapbarCriteria");
        historyOption = prefValue;
    }

    if (!critMenu) {
		alert(document.getElementById("bundle_yellowmapbar").getString("ymb.yellowmapbarUpdateCriteriaDropmarker.1"));
    }
    else {
        var critMenuDrop = mainDoc.getAnonymousElementByAttribute(critMenu, "class", "menulist-dropmarker");
        critMenuDrop.setAttribute("hidden", !historyOption);
    }

    // clear the history when it was switched off
    if (!historyOption) {
      yellowmapbarClearHistory( false ); // and clear the CriteriaBox
    }
}

function yellowmapbarInitHistory()
{
    var historyArray = new Array();
    try {
      var nsISupportsString = Components.interfaces.nsISupportsWString ||
        Components.interfaces.nsISupportsString;
      var string = ymbPref.getComplexValue("history", nsISupportsString).data;        
      historyArray = string.split("||");
    }
    catch(e) {
        dump("\nHistory init failure caught\n" + e);
    }

    // iterate over the saved history items and add them to the list
    // and make sure to use the second paramenter of the addToHistory
    // function so that we don't add it to the saved preference again
    for (var i = 0; i < historyArray.length; i++) {
        if (historyArray[i]) {
            yellowmapbarAddToHistory(historyArray[i], true);
        }
    }
}

function yellowmapbarInitMyLocations()
{
    var MyLocationsArray = new Array();
    try {
      var nsISupportsString = Components.interfaces.nsISupportsWString ||
        Components.interfaces.nsISupportsString;
      var string = ymbPref.getComplexValue("mylocations", nsISupportsString).data;        
      MyLocationsArray = string.split("||");
    }
    catch(e) {
        dump("\nMyLocations init failure caught\n" + e);
    }

    // iterate over the saved history items and add them to the list
    // and make sure to use the second paramenter of the addToHistory
    // function so that we don't add it to the saved preference again
    for (var i = 0; i < MyLocationsArray.length; i++) {
        if (MyLocationsArray[i]) {
            yellowmapbarAddToMyLocations(MyLocationsArray[i], true);
        }
    }

	// Standard-Location auf erstes Element in Liste
	var LocationBox = document.getElementById("yellowmapbarSearchLocation");
	LocationBox.selectedIndex = 0;
}


function yellowmapbarInitPrefs()
{ // this is a leftover from the early days.
	// We used to use a try yellowmapbarReadPref and catch the missing pref failures
	// here, and set them. Then the prefs grewup and they now have their own try
	// catch blocks for each pref. The way it was done before was ok, for a few
	// prefs. If you add a pref, the be sure to add it to both Firefox and Seamonkey
	// user interfaces. yellowmapbarPrefDialog.xul
    yellowmapbarReadPref();
}

function yellowmapbarReadPref() 
{
    /***********************************
       Modifier Key Action Preferences
     ***********************************/
     
    try { 
        altAction = ymbPref.getCharPref("ActionAlt");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionAlt", "0");  // Default
        altAction = ymbPref.getCharPref("ActionAlt");
    }
    
    try {
        altCtrlAction = ymbPref.getCharPref("ActionAltCtrl");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionAltCtrl", "0");  // Default
        altCtrlAction = ymbPref.getCharPref("ActionAltCtrl");
    }
    
    try {
        altShiftAction = ymbPref.getCharPref("ActionAltShift");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionAltShift", "0");  // Default
        altShiftAction = ymbPref.getCharPref("ActionAltShift");
    }      
    
    try {
        ctrlAction = ymbPref.getCharPref("ActionCtrl");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionCtrl", "0");  // Default
        ctrlAction = ymbPref.getCharPref("ActionCtrl");
    } 
        
    try {
        ctrlShiftAction = ymbPref.getCharPref("ActionCtrlShift");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionCtrlShift", "0");  // Default
        ctrlShiftAction = ymbPref.getCharPref("ActionCtrlShift");
    }      
        
    try {
        noneAction = ymbPref.getCharPref("ActionNone");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionNone", "0");  // Default
        noneAction = ymbPref.getCharPref("ActionNone");
    }        
        
    try {
        shiftAction = ymbPref.getCharPref("ActionShift");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("ActionShift", "0");  // Default
        shiftAction = ymbPref.getCharPref("ActionShift");
    }

    /*************************************
       Modifier Key Location Preferences
     *************************************/

    try {
        altLocation = ymbPref.getCharPref("LocationAlt");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationAlt", "0");  // Same Window
        altLocation = ymbPref.getCharPref("LocationAlt");
    }

    try {
        altCtrlLocation = ymbPref.getCharPref("LocationAltCtrl");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationAltCtrl", "0");  // Same Window
        altCtrlLocation = ymbPref.getCharPref("LocationAltCtrl");
    }

    try {
        altShiftLocation = ymbPref.getCharPref("LocationAltShift");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationAltShift", "0");  // Same Window
        altShiftLocation = ymbPref.getCharPref("LocationAltShift");
    }
   
    try {
        ctrlLocation = ymbPref.getCharPref("LocationCtrl");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationCtrl", "1");  // New Tab
        ctrlLocation = ymbPref.getCharPref("LocationCtrl");
    }

    try {
        ctrlShiftLocation = ymbPref.getCharPref("LocationCtrlShift");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationCtrlShift", "1");  // New Tab
        ctrlShiftLocation = ymbPref.getCharPref("LocationCtrlShift");
    }

    try {
        noneLocation = ymbPref.getCharPref("LocationNone");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationNone", "0");  // Same Window
        noneLocation = ymbPref.getCharPref("LocationNone");
    }
    
    try {
        shiftLocation = ymbPref.getCharPref("LocationShift");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref("LocationShift", "2");  // New Window
        shiftLocation = ymbPref.getCharPref("LocationShift");
    }

    /****************************************
       Domain Specific Preferences (Search)
     ****************************************/

    try {
        ymbcntry2SrchIx = ymbPref.getIntPref("country2Search");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setIntPref("country2Search", document.getElementById("bundle_yellowmapbar").getString("ymb.country_default"));
        ymbcntry2SrchIx = ymbPref.getIntPref("country2Search");
    }
            
    cntrySfxsInit();
    ymbLocaleCountry = cntrySfxs[ymbcntry2SrchIx]; 


    /***********************************
       Other Miscellaneous Preferences
     ***********************************/

    try {
        autoSearchOption = ymbPref.getBoolPref("autosearchoption");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("autosearchoption", true); // Auto Search When History Item Selected
        autoSearchOption = ymbPref.getBoolPref("autosearchoption");
    }

    try {
        cntxtmnuopt = ymbPref.getBoolPref("contextmenuoption");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("contextmenuoption", true);
        cntxtmnuopt = ymbPref.getBoolPref("contextmenuoption");
    }

    try {
        hideMenuOption = ymbPref.getBoolPref("hidemenuoption");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("hidemenuoption", false); // Hide Menu Items Promoted to Buttons
        hideMenuOption = ymbPref.getBoolPref("hidemenuoption");
    }

    try {
        historyOption = ymbPref.getBoolPref("historyoption");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("historyoption", true); // Save History    
        ymbPref.setCharPref("history", "yellowmapbar"); // History Value 
        historyOption = ymbPref.getBoolPref("historyoption");
    }

    try {
        hkeytgl = ymbPref.getBoolPref("hotkeySelectionToggles");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("hotkeySelectionToggles", false); // mimic ctrl-L or toggle
        hkeytgl = ymbPref.getBoolPref("hotkeySelectionToggles");
    }

    try {
        srch4SelAppnd = ymbPref.getBoolPref("search4SelectedAppends");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("search4SelectedAppends", false); // replace or append text
        srch4SelAppnd = ymbPref.getBoolPref("search4SelectedAppends");
    }

    try {
        maxHistCnt = ymbPref.getIntPref("maxHistCnt");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setIntPref("maxHistCnt", 10); // Maximum History Values Kept
        maxHistCnt = ymbPref.getIntPref("maxHistCnt");
    }

    try {
        queryStringOption = ymbPref.getBoolPref("querystringoption");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("querystringoption", false); // Ignore Query String for Up Dir Button
        queryStringOption = ymbPref.getBoolPref("querystringoption");
    }

    try {
        saveLastOption = ymbPref.getBoolPref("savelastoption");
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setBoolPref("savelastoption", false); // Save Last Search Type
        saveLastOption = ymbPref.getBoolPref("savelastoption");
    }

    try {
        ymb_init();
    }
    catch(e) { dump(  "\n" + e + "\n" );
    }

    try {
        setYellowMapContextMenu();
    }
    catch(e) {
		inFirebird = true; // It fails in current Firebird, though there are better ways to get this info
		if(DEBUG_USE_DUMPS)
		{
			dump("\n" + e + "\n");
			dump("\nYellowMapBar: ReadPref: trapping set YellowMapContextMenu error:\n");
        	dump("Ignore this warning on Firefox.\n" + e + "\n");
		}

		// workaround bug 6171
	    try {
	        historyOption = ymbPref.getBoolPref("historyoption");
	        maxHistCnt = ymbPref.getIntPref("maxHistCnt");
	        if(historyOption == "false") {
	        	ymbPref.setIntPref("maxHistCnt", 0);
	        	maxHistCnt = ymbPref.getIntPref("maxHistCnt");
	        	}
	    	}
	    catch(e2) { dump( e2 );
	    }
		// end workaround bug 6171

    }

	if(DEBUG_USE_DUMPS) dump("Finished ReadPrefs OK\n");
}

function ymb_init()
{
    if (!ymb_loaded) {
        window.removeEventListener("keypress",yellowmapbarDisplayCheck,true);
        window.removeEventListener("mousemove",yellowmapbarDisplayCheck,true);

        ymb_loaded = true;

        if(inFirebird == false){
        	check4NewInstall();
        	}

        var element = document.getElementById("LabelsButtonItem");

        if (element.getAttribute("checked") == "true") {
            yellowmapbarLabelsOn();
        }
        else {
            yellowmapbarLabelsOff();
        }

        var hideExtras = !(document.getElementById("extras-box").childNodes.length > 0);

        yellowmapbarGoPopupMenus();
        initCustomOrder(); // this function is actually in yellowmapbarDragAndDrop.js
		
        // Fix Me later this blows it in the very first run of the window init.
        // It must come after ymb_loaded is set. It seems fine after that
		// see bug 6109 for this suggestion... tests needed.
//		if ("XULBrowserWindow" in window &&
//		typeof(window.XULBrowserWindow.__yellowmapbar__onLocationChange) == 'undefined') {

        if ("XULBrowserWindow" in window && window.XULBrowserWindow.onLocationChange && (window.XULBrowserWindow.onLocationChange != onLocationChange)) {
            window.XULBrowserWindow.__yellowmapbar__onLocationChange = window.XULBrowserWindow.onLocationChange;
            window.XULBrowserWindow.onLocationChange = onLocationChange;
        }
    }
    else {

//		if ("XULBrowserWindow" in window &&
//		typeof(window.XULBrowserWindow.__yellowmapbar__onLocationChange) == 'undefined') {

        if ("XULBrowserWindow" in window && window.XULBrowserWindow.onLocationChange && (window.XULBrowserWindow.onLocationChange != onLocationChange)) {
            window.XULBrowserWindow.__yellowmapbar__onLocationChange = window.XULBrowserWindow.onLocationChange;
            window.XULBrowserWindow.onLocationChange = onLocationChange;

        }
        yellowmapbarGoPopupMenus();
    }


}

function onLocationChange(aWebProgress, aRequest, aLocation)
{
    if (aLocation)
    {
        var Url = aLocation.spec;
        var Criteria;

        if (/^\s*http:\/\/[^\.]*\.yellowmap\..*\/[^\?]*\?.*Catchword=([^&]*)/i.test(Url)) 
		{
            Criteria = ymbDecodeUri(RegExp.$1);

            var CriteriaBox = document.getElementById("yellowmapbarCriteria");
            CriteriaBox.value = Criteria;

            yellowmapbarCheckSearchbuttons();
            if (ymbHighlightOn) {
                yellowmapbarHighLightInPage("on");
            }
        }

        if (/^\s*http:\/\/[^\.]*\.yellowmap\..*\/[^\?]*\?.*BranchBC=([^&]*)/i.test(Url)) 
		{
            Criteria = ymbDecodeUri(RegExp.$1);

            var CriteriaBox = document.getElementById("yellowmapbarCriteria");
            CriteriaBox.value = Criteria;

            yellowmapbarCheckSearchbuttons();
            if (ymbHighlightOn) {
                yellowmapbarHighLightInPage("on");
            }
        }
		
        yellowmapbarUpdateNewWindow();
        yellowmapbarCheckSearchbuttons();

    }

    return window.XULBrowserWindow.__yellowmapbar__onLocationChange(aWebProgress, aRequest, aLocation);
}

function yellowmapbarCustomNavigation()
{
    if (!window._content.document) {
        return;
    }

    var url = window._content.document.location;
    var doc = window._content.document.documentElement;
    var aElems = doc.getElementsByTagName("A");

    var i = 0;
    var count = 0;

    for (i = 0; i < aElems.length; i++) {
        if (getAnchorURL(aElems[i], url)) {
            count++;
        }
    }

    if (count > 0) {
        lastResults = new Array(count);
    }
    else {
        lastResults = new Array(0);
        return;
    }

    count = 0;

    for (i = 0; i < aElems.length; i++) {
        if (getAnchorURL(aElems[i], url)) {
            lastResults[count] = getAnchorURL(aElems[i], url);
            count++;
        }
    }

    // alert("Set last results to\n" + lastResults.join("\n"));

    // also populate the last yellowmap result and set up the button appropriately
    lastYellowMap = url;

    var lastBtn = document.getElementById("last-button");
    lastBtn.removeAttribute("oncommand");
    lastBtn.setAttribute("disabled", false);
    lastBtn.setAttribute("onclick", "if (event.button == 1) { navGo(event, '" + url + "') }");
    lastBtn.setAttribute("oncommand", "navGo(event, '" + url + "');");
}

function getAnchorURL(element, baseURL)
{
    var href = element.getAttribute("href");
    var url;

    if (!href || /^\s*mailto:/i.test(href)) {
        return null;
    }
    else {
        stdUrl.spec = baseURL;
        url = stdUrl.resolve(href);
    }

    if (url) {
        return url;
    }
    else {
	alert(document.getElementById("bundle_yellowmapbar").getString("ymb.getAnchorURL.1") + "\n" + href);
        return null;
    }
}

function navGo(event, addy)
{
    yellowmapbarDoAction(addy, yellowmapbarGetLocFromEvent(event));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////// Main Search /////////////////////////////////

function yellowmapbarAutoSearch(event)
{
    yellowmapbarInitPrefs();
    if (autoSearchOption) {
        yellowmapbarSearch(event);
    }
}

function yellowmapbarSearch(event, searchType, searchParams)
{
    var win = window._content.document;
    var searchURL;

    // recover any pref changes like country and modifiers immediately
    yellowmapbarInitPrefs();

    if (!searchType) {
        searchType = yellowmapbarGetActFromEvent(event);
    }

	// Some things cannot be done in a new tab, such as formfilling and capturing.
    // bailing out beforehand
	if(searchParams == "NO_SEARCH") {

		if(gbDoNonSearch(event, searchType, searchParams));
			return; // we are already done
	}

	var CriteriaBox = document.getElementById("yellowmapbarCriteria");
	var Criteria = TrimString(CriteriaBox.value);
	var LocationBox = document.getElementById("yellowmapbarSearchLocation");
	var Location = TrimString(LocationBox.value);

	if ( Criteria == "" && Location != "" )
	{
		// Nur Karte von Ort
		searchType = "CityGuide" ;
	}
	else if( ymbLook4URL(event, searchType, searchParams)) 
	{
		// hold on and let the user beware of what they put in here
		// we will get more on this
		// FIX ME need to escape illegal characters
		searchType = "doUrlNav" ;
	}
	else if ( ymbLook4Address(event, searchType, searchParams)) 
	{
		searchType = "CityGuide" ;
		// Addresse im Stichwort-Feld nach Location-Box kopieren
		Location = Criteria;
		Criteria = '';
	}
	else if (Criteria.search(/\bin\b/i) != -1)
	{
		// Suchstring ist von der Form "Pizza in Karlsruhe"
		var RegexInSplit = /^\s*(.*)\s*\bin\b\s*(.*)\s*/i;
		RegexInSplit.exec(Criteria);

		Criteria = RegExp.$1;
		Location = RegExp.$2;
	}

	yellowmapbarClearTerms();

	var RadiusBox = document.getElementById("yellowmapbarSearchRadius");
	var Radius = RadiusBox.selectedItem.value;

	yellowmapbarAddTerm(Criteria);
	yellowmapbarAddToHistory(Criteria);
	yellowmapbarAddToMyLocations(Location);

	switch(searchType) 
	{
		case "doUrlNav":
			// use unescaped version:
			searchURL = Criteria;
			break;
		case "CityGuide":
			// Suche nach Ort im CityGuide
			searchURL = 'http://www.yellowmap.' + ymbLocaleCountry + '/YM/CityGuide/CityGuide.aspx?CityGuideView=2&AdminUnitType=5&Town=';
			searchURL += ymbParseAddressToUri(Location);
			searchURL += "&Radius=";
			searchURL += Radius;
			break;
		default:
			if (TrimString(Location) != "")
			{
				searchURL = 'http://www.yellowmap.' + ymbLocaleCountry + '/YM/Poi/Poi.aspx?Branch=';
				searchURL += ymbBuildUri(Criteria);
				searchURL += "&" + ymbParseAddressToUri(Location);
				searchURL += "&Radius=";
				searchURL += Radius;
			}
			else
			{
				// Suche nach Stichwort ohne Ort
				searchURL = 'http://www.yellowmap.' + ymbLocaleCountry + '/YM/Poi/Poi.aspx?Catchword=';
				searchURL += ymbBuildUri(Criteria);
			}
			break;
	}

	searchURL += "&RequestSourceId=mozclient";
	yellowmapbarDoAction(searchURL, yellowmapbarGetLocFromEvent(event));

	CriteriaBox.value = Criteria;
	LocationBox.value = Location;
}

function yellowmapbarGetLocFromEvent(event)
{
    // alert("ALT : " + event.altKey + "\nCTRL : " + event.ctrlKey + "\nSHIFT : " + event.shiftKey + "\n");
    if (event.button == 1) {
        return "New Tab";
    }
    if (event.altKey) {
        if (event.ctrlKey) {
            return arrDeckLocs[altCtrlLocation];
        }
        else if (event.shiftKey) {
            return arrDeckLocs[altShiftLocation];
        }
        else {
            return arrDeckLocs[altLocation];
        }
    }
    else if (event.ctrlKey) {
        if (event.shiftKey) {
            return arrDeckLocs[ctrlShiftLocation];
        }
        else {
            return arrDeckLocs[ctrlLocation];
        }
    }
    else if (event.shiftKey) {
        return arrDeckLocs[shiftLocation];
    }
    else {
        return arrDeckLocs[noneLocation];
    }
}

function yellowmapbarGetActFromEvent(event)
{
    if (event.altKey) {
        if (event.ctrlKey) {
            return arrDeckActs[altCtrlAction];
        }
        else if (event.shiftKey) {
            return arrDeckActs[altShiftAction];
        }
        else {
            return arrDeckActs[altAction];
        }
    }
    else if (event.ctrlKey) {
        if (event.shiftKey) {
            return arrDeckActs[ctrlShiftAction];
        }
        else {
            return arrDeckActs[ctrlAction];
        }
    }
    else if (event.shiftKey) {
        return arrDeckActs[shiftAction];
    }
    else {
        return arrDeckActs[noneAction];
    }
}

function yellowmapbarDoAction(searchURL, location)
{
    switch(location) {

    case "Same Window":
        window._content.document.location = searchURL;

		window.content.focus();
        break;

    case "New Tab":
        var browser = getBrowser();
        var tab = browser.addTab(searchURL, getReferrer(document));
        window.content.focus();

        // Hook this up -- have we init'ed prefRoot
        if (!prefRoot.getBoolPref("browser.tabs.loadInBackground")) {
            browser.selectedTab = tab;
        }
        break;

    case "New Window":
        window.open(searchURL);
        break;

    default:
        alert(document.getElementById("bundle_yellowmapbar").getString("ymb.error"));
        break;

    }
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// Support ///////////////////////////////////

function yellowmapbarEscape(term)
{
    // we need to handle both '/' and '+' specially
    term = encodeURIComponent(term);
    return term.replace(/\+/g,"%2B").replace(/\//g,"%2F");
}

function ymbDecodeUri(uri)
{
    var terms = uri.split("+");
    var result = "";

    for (var i = 0; i < terms.length; i++) {
        if (i > 0) {
            result += " ";
        }
        result += decodeURIComponent(terms[i]);
    }
    return result;
}

function ymbBuildUri(criteria)
{
    var terms = criteria.split(" ");
    var uri = "";

    for (var i = 0; i < terms.length; i++) {
        if (i > 0) {
            uri += "+";
        }
        uri += yellowmapbarEscape(terms[i]);
    }
    return uri;
}

function yellowmapbarPaste(event)
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var textBox;

    // attempt to grab selected text from the current document (tab)
    var text = _content.document.getSelection();

    // if nothing selected in the document then perhaps there is a
    // selection contained within a frame of the current document
    if (!text) {
        for (var i = 0; i < _content.frames.length; i++) {
            text = _content.frames[i].document.getSelection();
            if (text) break;
        }
    }

    // if still no text has been found then perhaps something in
    // the the location text box has been selected
    if (!text) {
        textBox = window.document.getElementById("urlbar");
        if (textBox.selectionStart >= 0) {
            text = textBox.value.substring(textBox.selectionStart, textBox.selectionEnd);
        }
    }

    // if still no text has been found then perhaps something in
    // the the criteria box has been selected - not sure why you
    // would want to search on something already in the criteria
    // box but hey, who am I to criticize
    // hmmm, here is a far fetched use case so I'll leave this code
    // for now - someone may have multiple terms in the criteria
    // box and may want to only search on one of them, highlighting
    // that single term and then shift+click on highlight search
    // button would search on that term alone - not likely, but a use case
    if (!text) {
        textBox = document.getElementById("yellowmapbarCriteria");
        if (textBox.selectionStart >= 0) {
            text = textBox.value.substring(textBox.selectionStart, textBox.selectionEnd);
        }
    }

    // if we have found some selected text then set the criteria
    // box to that value and reset the search term buttons,
    // otherwise display an error message via an alert
    if (text) {

        // if there was no previous text or the shift key was pressed
        // then change the value to the selected text, otherwise append
        // the text to the end of what was already there.  after that
        // then the search term buttons need to be updated

    	if (!CriteriaBox.value){
			CriteriaBox.value = text;
        }
        else
        {
	        if(event.shiftKey) {
				srch4SelAppnd ? CriteriaBox.value = text : CriteriaBox.value += " " + text;
	        }
	        else {
				srch4SelAppnd ? CriteriaBox.value += " " + text : CriteriaBox.value = text;
	        }
        }


    try {
		// Just sneak in a pref change for this
		// one search and reset it when done.
		// better have this already!!
		var savedPref = noneLocation ;
        ymbPref.setCharPref("LocationNone", "1");  // New Tab

		// New text in box, so update the buttons...
        yellowmapbarCheckSearchbuttons();
        // Do it.
        if(srch4SelAppnd == event.shiftKey)
	        yellowmapbarSearch(event);

        ymbPref.setCharPref("LocationNone", savedPref);
    }
    catch(e) { dump(  "\n" + e + "\n" );
	dump("\nCouldn't set LocationNone pref for yellowmapbarPaste\n");
    }


    }
    else {
// Still NO text!!!
// Now we'll look for forms input boxes
// yes, try and get the text
// no, emit our default nothing selected msg early on!!!
    	
       var formsArray = content.document.forms;
       if (!formsArray) {
	        alert(document.getElementById("bundle_yellowmapbar").getString("ymb.select_before"));
			return;
	   }

       var form;
 
       for (form=0; form<formsArray.length; form++) {
         var elementsArray = formsArray[form].elements;
         var element;

         for (element=0; element < elementsArray.length; element++) {
         var type = elementsArray[element].type;
           if ((type=="text") || (type=="textarea")) {
			 if( elementsArray[element].selectionStart != elementsArray[element].selectionEnd) {
			   // stuffit into our criteriaBox
			 text = elementsArray[element].value.substring(elementsArray[element].selectionStart, elementsArray[element].selectionEnd);
			 CriteriaBox.value = text;
	        
			try {
				// Just sneak in a pref change for this
				// one search and reset it when done.
				// could call it like this but... 
				// ymbPref.getCharPref("LocationNone"); 
				// better have this already!!

				var savedPref = noneLocation ;  
				ymbPref.setCharPref("LocationNone", "1");  // New Tab as default
				
				// New text in box, so update the buttons...
				yellowmapbarCheckSearchbuttons();
				// Do it
				yellowmapbarSearch(event);
				ymbPref.setCharPref("LocationNone", savedPref);
			}
			catch(e) { dump(  "\n" + e + "\n" );
				dump("\nCouldn't set LocationNone pref for yellowmapbarPaste\n");
			}


     } // Selection start and end are different

    } // ((type=="") || (type=="text") || (type=="input")) 
   } // for (element=0; element < elementsArray.length; element++) 
  } // for (form=0; form<formsArray.length; form++) 
 } // else 


}

function yellowmapbarFindTerms(criteria)
{
    //  quotes only matter when preceded by a space or a quote.
    var terms    = new Array();
    var val, testIndx;
	var tempval  = criteria;
    var inQuote  = false;
    var haveTerm = false;

    var currPtr  = 0;    // the start of the current term
    var prevChar = ' ';  // the char we last saw
	// JW. I have little experience with this function but what was there would only handle one word.
    // So I hope this doesn't break things.
    try { testIndx = tempval.search(/(cache|link|related|stocks|define|site|allintitle|intitle|allinurl|inurl|filetype|group):/g); }
	    catch(e){ } // nothing
	if(testIndx != -1) {
		tempval = tempval.slice(1 + tempval.indexOf(":"), tempval.length );
		criteria = tempval ;
		}
	
    for (var index = 0; index < criteria.length; index++) {
        var currChar = criteria.charAt(index);

        switch (currChar) {
          
        case ' ':
        case '+':
        case '(':
        case ')':
        case '~':
          // these characters do not occur on the search term buttons, 
          // except in quoted phrases
          if (!inQuote && haveTerm) {
            val = TrimString(criteria.substring(currPtr, index));
            if (!isIn(terms, val)) {
              if (val != 'OR' && val[0] != '-') {
                terms.push(val);
              }
            }
            haveTerm = false;
          }
          break;
          
        case '"':
          // phrases (enclosed in "") should result in only one button
          if (!inQuote) {
              if (haveTerm) {
                  val = TrimString(criteria.substring(currPtr, index));
                  if (!isIn(terms, val)) {
                      terms.push(val);
                  }
                  haveTerm = false;
              }

              // any of the discardable characters can occur before a phrase
              if ((prevChar == ' ') 
                  || (prevChar == '"')
                  || (prevChar == '(')
                  || (prevChar == ')')
                  || (prevChar == '+')
                  || (prevChar == '~')
                ) {
                  inQuote = true;
              }
          }
          else {
              if (haveTerm) {
                val = /*TrimString(*/criteria.substring(currPtr, index)/*)*/;
                  if (!isIn(terms, val)) {
                      terms.push(val);
                  }
                  haveTerm = false;
                  inQuote = false;
              }
          }
          break;
          
        default:
            if (!haveTerm) {
                haveTerm = true;
                currPtr = index;
            }
        }
        prevChar = currChar;
    }
    val = TrimString(criteria.substring(currPtr, index));
	// FIX ME this only gets executed on the last term in a group
    // I'll leave it for now. jw.
    if (haveTerm && !isIn(terms, val) ) {
      // remove special prefixes
      val = val.replace(/(cache|link|related|stocks|define|site|allintitle|intitle|allinurl|inurl|filetype|group):/,'');
      
      if (val != 'OR' && val[0] != '-') {
        terms.push(val);
      }
    }
    
    return terms;
}

function yellowmapbarAddToMyLocations(term, ignorePref)
{
    var LocationBox = document.getElementById("yellowmapbarSearchLocation");
    var MyLocationsMenu = LocationBox.childNodes.item(0);

    var numHistItems = MyLocationsMenu.childNodes.length;
    var alreadyInHist = false;
    var i = 0;

    // iterate over the current history and check if the term is
    // already there
    for (i = 0; i < numHistItems; i++) {
        if (term == MyLocationsMenu.childNodes[i].getAttribute("label")) {
            alreadyInHist = true;
        }
    }

    // add to history
    if (!alreadyInHist) {
        var myMenuItem = document.createElement("menuitem");
        myMenuItem.setAttribute("label", term);

        if (numHistItems <= 0) {
            MyLocationsMenu.appendChild(myMenuItem);
        }
        else {
            MyLocationsMenu.insertBefore(myMenuItem, MyLocationsMenu.childNodes[0]);
        }

        numHistItems++;

        if (!ignorePref) {
            yellowmapbarAddToMyLocationsPref(term);
        }

        // if too many items have been added then remove extra items from the bottom
        if (numHistItems > ymbMaxMyLocationsCount) {
            var numToRemove = numHistItems - ymbMaxMyLocationsCount;

            // iterate over the current history and remove any extraneous items
            for (i = 1; i <= numToRemove; i++) {
                MyLocationsMenu.removeChild(MyLocationsMenu.lastChild);
            }
            yellowmapbarRefreshMyLocationsPref();
        }
    }
}

function yellowmapbarAddToHistory(term, ignorePref)
{
    // This function adds the string "term" to the search
    // history *only* if it is not already there
	// Robert, we should probably remove the term from it's location in the list,
	// and then put it at the top of the list. My favorite terms roll off the list,
	// even when I use them frequently. waddya think? jw

    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var historyMenu = CriteriaBox.childNodes.item(0);

    var numHistItems = historyMenu.childNodes.length;
    var alreadyInHist = false;
    var i = 0;

    // iterate over the current history and check if the term is
    // already there
    for (i = 0; i < numHistItems; i++) {
        if (term == historyMenu.childNodes[i].getAttribute("label")) {
            alreadyInHist = true;
        }
    }

    // add to history
    if (!alreadyInHist) {
        var myMenuItem = document.createElement("menuitem");
        myMenuItem.setAttribute("label", term);
        myMenuItem.setAttribute("oncommand", "yellowmapbarAutoSearch(event);");

        if (numHistItems <= 0) {
            historyMenu.appendChild(myMenuItem);
        }
        else {
            historyMenu.insertBefore(myMenuItem, historyMenu.childNodes[0]);
        }

        numHistItems++;

        if (!ignorePref) {
            yellowmapbarAddToHistoryPref(term);
        }

        // if too many items have been added then remove extra items from the bottom
        if (numHistItems > maxHistCnt) {
            var numToRemove = numHistItems - maxHistCnt;

            // iterate over the current history and remove any extraneous items
            for (i = 1; i <= numToRemove; i++) {
                historyMenu.removeChild(historyMenu.lastChild);
            }
            yellowmapbarRefreshHistoryPref();
        }
    }
}

function yellowmapbarAddToMyLocationsPref(term)
{
    // This function should only be called after it has
    // been established that this item is not already
    // in the list of items (see yellowmapbarAddToMyLocations)
    // otherwise there may be duplicate items added to
    // the history.  There could be a check to see whether
    // it exists here as well to prevent this problem
    // but it doesn't appear to be necessary at this point
    // since this function is only called from within the
    // yellowmapbarAddToMyLocations function.
    //
    // Another potential problem that should be addressed
    // is to check whether or not the || delimeter is
    // contained in the search term, if it is then it will
    // cause a problem when the history is reloaded.

    var nsISupportsString;

	var sMyLocations = "";
	var sSearch = term;

	if (!sSearch) {
		return;
	}

	try {
		nsISupportsString = Components.interfaces.nsISupportsWString ||
		Components.interfaces.nsISupportsString;
		sMyLocations = ymbPref.getComplexValue("mylocations", nsISupportsString).data;
	}
	catch(e) {
		dump("\nMyLocations get pref err\n" + e );
		sMyLocations = ymbPref.setCharPref("mylocations", "placeholder");
	}

	if (sMyLocations) {
		sMyLocations = sMyLocations + sep + sSearch;
	}
	else {
		sMyLocations = sSearch;
	}

	var string = (Components.classes['@mozilla.org/supports-wstring;1']) ?
	  Components.classes['@mozilla.org/supports-wstring;1']
	  .createInstance(nsISupportsString) :
	  Components.classes['@mozilla.org/supports-string;1']
	  .createInstance(nsISupportsString) ;
	string.data =  sMyLocations;
	ymbPref.setComplexValue("mylocations", nsISupportsString, string);
}

function yellowmapbarAddToHistoryPref(term)
{
    // This function adds the string "term" to the search
    // history preference *only* if the option to save
    // search history is selected.
    //
    // This function should only be called after it has
    // been established that this item is not already
    // in the list of items (see yellowmapbarAddToHistory)
    // otherwise there may be duplicate items added to
    // the history.  There could be a check to see whether
    // it exists here as well to prevent this problem
    // but it doesn't appear to be necessary at this point
    // since this function is only called from within the
    // yellowmapbarAddToHistory function.
    //
    // Another potential problem that should be addressed
    // is to check whether or not the || delimeter is
    // contained in the search term, if it is then it will
    // cause a problem when the history is reloaded.

    var nsISupportsString;

    if (historyOption) {
        var sHistory = "";
        var sSearch = term;

        if (!sSearch) {
            return;
        }

        try {
            nsISupportsString = Components.interfaces.nsISupportsWString ||
            Components.interfaces.nsISupportsString;
            sHistory = ymbPref.getComplexValue("history", nsISupportsString).data;
        }
        catch(e) {
            dump("\nHistory get pref err\n" + e );
            sHistory = ymbPref.setCharPref("history", "placeholder");
        }

        if (sHistory) {
            sHistory = sHistory + sep + sSearch;
        }
        else {
            sHistory = sSearch;
        }

        // This appears to be duplicated code from the try block above.
        // Going to comment this out until it is determined that it is
        // actuall necessary to have it.
        /*
        nsISupportsString = Components.interfaces.nsISupportsWString ||
          Components.interfaces.nsISupportsString;
        */

        var string = (Components.classes['@mozilla.org/supports-wstring;1']) ?
          Components.classes['@mozilla.org/supports-wstring;1']
          .createInstance(nsISupportsString) :
          Components.classes['@mozilla.org/supports-string;1']
          .createInstance(nsISupportsString) ;
        string.data =  sHistory;
        ymbPref.setComplexValue("history", nsISupportsString, string);
    }
}

function yellowmapbarRefreshMyLocationsPref()
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var MyLocationsMenu = CriteriaBox.childNodes.item(0);
    var numHistItems = MyLocationsMenu.childNodes.length;

    // sync up the history preference with the new list
    ymbPref.setCharPref("mylocations", "");

    for (i = numHistItems - 1; i >= 0; i--) {
        yellowmapbarAddToHistoryPref(MyLocationsMenu.childNodes[i].getAttribute("label"));
    }
}

function yellowmapbarRefreshHistoryPref()
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var historyMenu = CriteriaBox.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;

    // sync up the history preference with the new list
    ymbPref.setCharPref("history", "");

    for (var i = numHistItems - 1; i >= 0; i--) {
        yellowmapbarAddToHistoryPref(historyMenu.childNodes[i].getAttribute("label"));
    }
}
// XXX
function yellowmapbarClearHistory( aflag )
{
	// introduced a parm to indicate whether to clear the CriteriaBox and search buttons
	// true when called by user, false when used otherwise.
	
    // This function removes all items from the search
    // history (both history pref and popup menu)
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");

    // If called from the prefs, we need to get the main document
    // first.
    if (!CriteriaBox) {
      mainDoc = top.opener.document;
      CriteriaBox = mainDoc.getElementById("yellowmapbarCriteria");
    }
    if (!CriteriaBox)
		alert(document.getElementById("bundle_yellowmapbar").getString("ymb.yellowmapbarClearHistory.1"));

	var saveCurrCrit = CriteriaBox.value;
    var historyMenu = CriteriaBox.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;


    // iterate over the current history and remove each item
    for (var i = numHistItems - 1; i >= 0; i--) {
        historyMenu.removeChild(historyMenu.childNodes[i]);
    }

    // next clear all the term buttons, the input field
    // (by setting selected index to -1), and history pref
    yellowmapbarClearTerms();
    CriteriaBox.selectedIndex = -1;
    ymbPref.setCharPref("history", "");
    
    // When the history is cleared all highlighting must be removed
    yellowmapbarCheckHighlight("");

	// some people want this cleared, bug 6430, 6462
    // so... when invoked by user actions, we don't restore it
    // only invoked in the main pulldown menu at present.
	if(!aflag){
	    if(saveCurrCrit)
	    CriteriaBox.value=saveCurrCrit;
		yellowmapbarAddTerm(saveCurrCrit);
	}
}

function yellowmapbarAddTerm(term)
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var mySearchTermBox = document.getElementById("yellowmapbarSearchTerms");
    var mySearchTermMenu = document.getElementById("searchterms-menu");
    var mySearchTermPopup = document.getElementById("searchterms-popup");
    var myTerms = yellowmapbarFindTerms(term);
    var tempNode, tempValue;
    var searchTermWidth = 0;
    var availableWidth = yellowmapbarAvailableWidth();
    mySearchTermBox.setAttribute("yellowmapbaroverflow",false);
    var overflow = false;

    for (var i = 0; i < myTerms.length; i++) {
        tempNode = document.createElement("text");
        tempNode.setAttribute("value", myTerms[i]);
        //tempNode.setAttribute("className", "yellowmapBarSearchTerm");
        tempNode.className = "yellowmapBarSearchTerm";
        tempValue = myTerms[i].replace(/\\/, "\\\\");
        tempNode.setAttribute("onclick", "yellowmapbarFindInPage(\"" + tempValue + "\" \,event \)");

        if (ymbHighlightOn) {
            // for some reason, the following line does not work (the style attribute is set 
            // but not honored by mozilla), so we have to use a global class
            // tempNode.setAttribute("style", "background-color:" + termColor[i%10]);
            tempNode.className = "yellowmapBarSearchTerm coloredSearchTerm"+(i%10);
            
        }
        mySearchTermBox.appendChild(tempNode);
        searchTermWidth = mySearchTermBox.boxObject.width;

        // check if buttons fit, if not, remove the last button
        // and add it to the overflow menu
        if (searchTermWidth > availableWidth) {
            mySearchTermPopup.appendChild(tempNode);
            mySearchTermMenu.setAttribute("hidden",false);
            overflow = true;
            mySearchTermBox.setAttribute("yellowmapbaroverflow",true);
        }
        else {
            if (mySearchTermBox.getAttribute("yellowmapbaroverflow")=="false") {
                mySearchTermMenu.setAttribute("hidden",true);
            }
        }
    }

    if (myTerms.length > 0) {
      document.getElementById("highlight-button").setAttribute("disabled", false);
    }
}

function yellowmapbarCheckHighlight(critValue)
{
    var myTerms = yellowmapbarFindTerms(critValue);
    var myHighlightButton = document.getElementById("highlight-button");
    
    if (myTerms.length > 0) {
        if (ymbHighlightOn) {
            yellowmapbarHighLightInPage("on");
        }
        myHighlightButton.setAttribute("disabled", false);
    }
    else {
        if (ymbHighlightOn) {
            yellowmapbarHighLightInPage("off");
            ymbHighlightOn = false;
        }
        myHighlightButton.setAttribute("disabled", true);
    }
}

function yellowmapbarCheckSearchbuttons()
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    yellowmapbarClearTerms();
    yellowmapbarAddTerm(CriteriaBox.value);
}

function yellowmapbarAvailableWidth()
{
    // This function returns the width which is available for the
    // search term buttons
    var width=0;

    width += document.getElementById("yellowmap-menu").parentNode.boxObject.width;
    width -= document.getElementById("yellowmap-menu").boxObject.width;
    width -= document.getElementById("search-textbox").boxObject.width;
    width -= document.getElementById("resize-splitter").boxObject.width;
    width -= document.getElementById("yellowmapbar-buttons").boxObject.width;
    return width;
}

function yellowmapbarClearCrit()
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    CriteriaBox.value = "";
}

function yellowmapbarClearTerms()
{
    var termBox = document.getElementById("yellowmapbarSearchTerms");
    var termPopup = document.getElementById("searchterms-popup");
    for (var numTerms = termBox.childNodes.length; numTerms > 0; numTerms--) {
        termBox.removeChild(termBox.childNodes[0]);
    }
    for (numTerms = termPopup.childNodes.length; numTerms > 0; numTerms--) {
        termPopup.removeChild(termPopup.childNodes[0]);
    }
    termBox.setAttribute("yellowmapbaroverflow",false);
}

function yellowmapbarHideItem(event)
{
    var item = event.target;
    var ggbItem = item.getAttribute("yellowmapbaritem");
    var ggbButton, ggbMenuitem;

    ggbButton = document.getElementById(ggbItem );
    ggbButton.setAttribute("hidden", !item.getAttribute("checked"));

    if (hideMenuOption && ggbItem.indexOf("-separate") > 0) {
        ggbItem = ggbItem.replace("-separate", "");
        ggbMenuitem = document.getElementById(ggbItem);

        if (ggbMenuitem) {
            ggbMenuitem.setAttribute("hidden", item.getAttribute("checked"));
        }
    }

    yellowmapbarCheckSearchbuttons();
}

function yellowmapbarLabels(event)
{
    if (event.target.getAttribute("checked")) {
        yellowmapbarLabelsOn();
    }
    else {
        yellowmapbarLabelsOff();
    }
}

function yellowmapbarLabelsOn()
{
    var container = document.getElementById("yellowmapbar-buttons");
    var containerButtons = container.getElementsByTagName("toolbarbutton");

    for (var i = 0; i < containerButtons.length; i++) {
        containerButtons[i].setAttribute("label", containerButtons[i].getAttribute("buttonlabel"));
        updateElementClass(containerButtons[i], 0, "button-labeled");
    }
}

function yellowmapbarLabelsOff()
{
    var container = document.getElementById("yellowmapbar-buttons");
    var containerButtons = container.getElementsByTagName("toolbarbutton");

    for (var i = 0; i < containerButtons.length; i++) {
        containerButtons[i].removeAttribute("label");
        updateElementClass(containerButtons[i], 0, containerButtons[i].getAttribute("buttonclass"));
    }
}


function yellowmapbarFindInPage(str, evt)
{
  /* This is shamelessly taken from Firebird findUtils.js */
  var found = false;
  var focusedWindow = document.commandDispatcher.focusedWindow;
  if (!focusedWindow || focusedWindow == window)
    focusedWindow = window._content;
  var findInst = getBrowser().webBrowserFind;
  var findInFrames = findInst.QueryInterface(Components.interfaces.nsIWebBrowserFindInFrames);
  findInFrames.rootSearchFrame = window._content;
  findInFrames.currentSearchFrame = focusedWindow;

  // setup the find instance
  findInst.searchString  = str;

  if(evt)
{
  // we hardcode the search options here with what seems to make most sense
  findInst.searchFrames = true;
  findInst.matchCase     = evt.ctrlKey;
  findInst.wrapFind      = true;
  findInst.entireWord = evt.altKey;
  findInst.findBackwards = evt.shiftKey;
  if(findInst.entireWord)
  findInst.searchString  = ' ' + str + ' ';
}
  found = findInst.findNext();

  if (!found) {
    alert(str + ' ' + document.getElementById("bundle_yellowmapbar").getString("ymb.notfound"));
  }
}

function yellowmapbarRefreshHighlight()
{
    var hiBtn = document.getElementById("highlight-button");
    hiBtn.click();
    hiBtn.click();
}

function yellowmapbarHighLightInPage(override)
{
    // Initialize to current document
    var gTheDocument = window._content.document;
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var term = CriteriaBox.value;

    if (ymbHighlightOn) {
        ymbHighlightOn = false;
        highlightDoc(null, null);
        yellowmapbarCheckSearchbuttons();
        // Exit if the term had not changed
        //  => means that the user clicked to remove highlighting
        if (gHighlightString == term  && override != "on") {
            return;
        }
    }

    ymbHighlightOn = true;
    gHighlightString = term;

    // wanted to use selection to extend to the word
    // and compare with the found range, in order to match
    // only whole words
    
    // Save selection
/*
    gSelection = window._content.getSelection();
    gSaveSelection = new Array();
    for (var i = 0; i < gSelection.rangeCount; i++) {
        gSaveSelection.push(gSelection.getRangeAt(i));
    }
    gSelection.removeAllRanges();
*/
    var myTerms = yellowmapbarFindTerms(term);
    for (var i = 0; i < myTerms.length; i++) {
        highlightDoc(myTerms[i], termColor[i %10]);
    }
/*
    // Revert to previous selection
    gSelection.removeAllRanges();
    for (var i = 0; i < gSaveSelection.length; i++) {
        gSelection.addRange(gSaveSelection[i]);
    }
*/
    yellowmapbarCheckSearchbuttons();
}

function highlightDoc(word, color, win)
{
    if (!win) {
        // This appears to only highlight the current tab.
        // Rather than grab _content we can get the window
        // itself and highlight all the tabs at once.
        //
        // win = window._content;
        win = window.self;
    }

    for (var i = 0; win.frames && i < win.frames.length; i++) {
        highlightDoc(word, color, win.frames[i]);
    }

    var doc = win.document;
    if (!document) {
        return;
    }

    // Remove highligthing
    if (!color) {
        var elem = null;
        while ((elem = doc.getElementById("yellowmap-search-id"))) {
            var child = null;
            var docfrag = doc.createDocumentFragment();
            var next = elem.nextSibling;
            var parent = elem.parentNode;
            while((child = elem.firstChild)) {
                docfrag.appendChild(child);
            }
            parent.removeChild(elem);
            parent.insertBefore(docfrag, next);
        }
        return;
    }


    if (!("body" in doc)) {
        return;
    }
    var body = doc.body;
   
    var count = body.childNodes.length;
    searchRange = doc.createRange();
    startPt = doc.createRange();
    endPt = doc.createRange();

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + color + ";");
    baseNode.setAttribute("id", "yellowmap-search-id");

    searchRange.setStart(body, 0);
    searchRange.setEnd(body, count);

    startPt.setStart(body, 0);
    startPt.setEnd(body, 0);
    endPt.setStart(body, count);
    endPt.setEnd(body, count);
    highlightText(word, baseNode);
}

function highlightText(word, baseNode)
{
    var retRange = null;
    while((retRange = ymbFinder.Find(word, searchRange, startPt, endPt))) {
        // check that we have a whole word
        //gSelection.addRange(range);

        // Highlight
        var nodeSurround = baseNode.cloneNode(true);
        var node = highlight(retRange, nodeSurround);
        startPt = node.ownerDocument.createRange();
        startPt.setStart(node, node.childNodes.length);
        startPt.setEnd(node, node.childNodes.length);
    }
}

function highlight(range, node)
{
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;
    var endOffset = range.endOffset;
    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
}

function buildUrl(pathArray, offset)
{
    var mystr = '';
    for (var i = 0; i < offset; i++) {
        if (pathArray[i].length) {
            mystr += pathArray[i];
            if (i < (offset-1)) {
              if (i == 0)                      
                if (pathArray[i] == "file:")
                  mystr += "/";             
              mystr += "/";
              // if it's the first item (protocol) then add a second /
              if (i == 0) mystr += "/";
            }
        }
    }

    // append trailing slash 
    mystr += "/";

    return mystr;
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////// Some helper functions /////////////////////////////////

function isIn(arr, str)
{
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].toLowerCase() == str.toLowerCase()) {
            return true;
        }
    }
    return false;
}

function TrimString(string)
{
    if (!string) return "";
    return string.replace(/(^\s+)|(\s+$)/g, '');
}

function normalizeString(string)
{
    if (!string) return "";
    var newString = "";

    // trim leading and trailing spaces
    newString = string.replace(/(^\s+)|(\s+$)/g, '');

    // reduce runs of more than one space to one space only
    newString = newString.replace(/(\s+)/g, ' '); // a space

    return newString;
}

function yellowmapbarCriteriaFocus()
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    CriteriaBox.focus();
}

function getFocusedElement() {
  var ff = document.getElementsByAttribute("focused",true);
  return ff.length ? ff[0] : null;
}

// Stateful Show/Focus: interact with the YellowMapBar given its current state
// using a single keyboard shortcut.  The possible state transitions are
//
//  - If the toolbar is hidden, toggle (show) it and focus on the criteria box
//
//  - If the criteria box is in focus and ...
//     - ... it has no text, fill in and select a default tooltip
//     - ... it has less than all of its text selected, select all its text
//     - ... it has all of its text selected, toggle (hide) the toolbar
//
//  - If the criteria box is blurred, then focus on it
//
// Before focus is given to the criteria box, the element with the current
// focus is saved.  When the toolbar is then later hidden, focus is restored
// to that saved element.

function yellowmapbarStatefulShowFocus() {

  var yellowmapbar = document.getElementById( "yellowmapbar" );
  var CriteriaBox = document.getElementById( "yellowmapbarCriteria" );

  if( yellowmapbar.hidden ) {

    gStatefulPrevFocus = getFocusedElement();
    goToggleToolbar( "yellowmapbar", "cmd_yellowmapbarShowHide" );
    CriteriaBox.focus();

  } else if( CriteriaBox.getAttribute("focused") ) {

    if( CriteriaBox.inputField.textLength == 0 ) {

      CriteriaBox.value = "YellowMapBar \"Enter your search text\"";
      CriteriaBox.inputField.select();

    } else {

      var curClickStart = CriteriaBox.inputField.selectionStart;
      var curClickEnd = CriteriaBox.inputField.selectionEnd;
      var curSelSize = curClickEnd - curClickStart;

      if( curSelSize < CriteriaBox.inputField.textLength ) {

	CriteriaBox.inputField.select();

      } else {

	if( gStatefulPrevFocus != null ) { gStatefulPrevFocus.focus(); }
	else { window.content.focus(); }
	goToggleToolbar( "yellowmapbar", "cmd_yellowmapbarShowHide" );

      }
    }

  } else {

    gStatefulPrevFocus = getFocusedElement();
    CriteriaBox.focus();

  }
}

function yellowmapbarCriteriaSelect(event)
{


    var CriteriaBox = document.getElementById("yellowmapbarCriteria");
    var ePt = CriteriaBox.inputField.textLength;
    var curClickStart = CriteriaBox.inputField.selectionStart;
    var curClickEnd = CriteriaBox.inputField.selectionEnd;
    var curSelSize = curClickEnd - curClickStart;

    if (event && ePt > 0) {
        switch(event.type) {

        case "dblclick":
            if (!boolCritSelected) {
                CriteriaBox.inputField.select();
                boolCritSelected = true;
            }
            else {
                CriteriaBox.inputField.setSelectionRange(curClickStart, curClickEnd);
                boolCritSelected = false;
            }
            break;

        case "focus":
            if (critIgnoreFocus) {
                critIgnoreFocus = false;
            }
            else {
                if (boolCritSelected) {
                    if (hkeytgl) {
                        CriteriaBox.inputField.setSelectionRange(0, 0 );
                        boolCritSelected = false;
                    }
                    else {
                        CriteriaBox.inputField.select();
                    }
                }
                else {
                    CriteriaBox.inputField.select();
                    boolCritSelected = true;
                }
            }
            break;

        case "mousedown":
            if (CriteriaBox.getAttribute("focused")) {
                critIgnoreClick = true;
            }
            else {
                critIgnoreFocus = true;
                critIgnoreClick = false;
                CriteriaBox.inputField.setSelectionRange(0, 0 );
                boolCritSelected = true;
            }
            break;

        case "click":
            if (!critIgnoreClick && curSelSize == 0) {
                CriteriaBox.inputField.select();
                boolCritSelected = true;
            }
            break;

        default:
            break;

        }
    } // no event or text


}

function yellowmapbarGoPopupMenus()
{
    var ggbPopupInUse = document.getElementById("yellowmapbar-buttons");

    yellowmapbarSyncMainPopup("ymbsearch-separate", "SearchButtonItem");
    
    yellowmapbarSyncMainPopup("yellowmapbarSearchTerms", "SearchTermsButtonItem");

    var element = document.getElementById("OrderLockButtonItem");
    if (element.getAttribute("checked") == "true") {
        lockOrdinalOrder();
    }
    else {
        unlockOrdinalOrder();
    }
}

function yellowmapbarSyncMainPopup(src, dest)
{
    var ggbButtonState = document.getElementById(src);
    var ggbPopupChecked = document.getElementById(dest);

    ggbPopupChecked.setAttribute("checked", !(ggbButtonState.getAttribute("hidden") == "true"));

    if (hideMenuOption && src.indexOf("-separate") > 0) {
        var ggbItem = src.replace("-separate", "");
        var ggbMenuitem = document.getElementById(ggbItem);

        if (ggbMenuitem) {
            ggbMenuitem.setAttribute("hidden", !(ggbButtonState.getAttribute("hidden") == "true"));
        }
    }
}

function yellowmapbarSyncMenuButton(ggbButton, ggbOption)
{
    // If there was a previous search selected for the
    // menu button and the preference is set to save
    // these settings then attempt to restore the
    // selection, if possible, otherwise just ignore it

    if (!saveLastOption) {
        return;
    }

    var optionValue;

    try {
        optionValue = ymbPref.getCharPref(ggbOption);
    }
    catch(e) { dump(  "\n" + e + "\n" );
        ymbPref.setCharPref(ggbOption, "");
        optionValue = "";
    }

    var menuButton = document.getElementById(ggbButton);
    var separateButton = document.getElementById(optionValue + "-separate");

    if (!menuButton || !separateButton) {
        return;
    }

    menuButton.removeAttribute("oncommand");
    menuButton.setAttribute("oncommand", separateButton.getAttribute("oncommand"));

    menuButton.setAttribute("buttonclass", separateButton.getAttribute("buttonclass"));
    menuButton.setAttribute("buttonlabel", separateButton.getAttribute("buttonlabel"));
    menuButton.setAttribute("class", separateButton.getAttribute("class"));

    if (separateButton.getAttribute("label")) {
        menuButton.setAttribute("label", separateButton.getAttribute("label"));
    }
}

function yellowmapbarCriteriaTooltip()
{
    var CriteriaBox = document.getElementById("yellowmapbarCriteria");

    if (CriteriaBox.value) {
        CriteriaBox.tooltipText = CriteriaBox.value;
    }
    else {
        CriteriaBox.tooltipText = CriteriaBox.statusText;
    }
}

function srchFlipflop()
{
    var ymbsrchterms = document.getElementById("yellowmapbarSearchTerms");
    var searchTermMenu = document.getElementById("searchterms-menu");
    ymbsrchterms.setAttribute("hidden", !ymbsrchterms.hidden );

    // when we are overflowing, set the hidden status of the overflow
    // menu accordingly
    if (ymbsrchterms.getAttribute("yellowmapbaroverflow")=="true") {
        searchTermMenu.setAttribute("hidden", ymbsrchterms.hidden );
    }

    // when the search buttons were unhidden, we have to check
    // if they fit
    if (!ymbsrchterms.hidden) {
        yellowmapbarCheckSearchbuttons();
    }
    return true;
}

function setYellowMapContextMenu()
{
    // our broadcaster doesn't get implemented in phoenix, and this error
	// is how we know where we are.
	
    var inPrefs = false;
    var cntxtmnuopt;

    var cntxtmnu = document.getElementById('yellowmapbar_contextpref');
    if (!cntxtmnu) {
        cntxtmnu = top.opener.document.getElementById('yellowmapbar_contextpref');
        inPrefs = true;
    }

    if (inPrefs) {
        cntxtmnuopt = document.getElementById('contextmenuoption').checked;
    }
    else {
        cntxtmnuopt = ymbPref.getBoolPref("contextmenuoption");
    }

    if (cntxtmnuopt) {
        cntxtmnu.setAttribute('hidden', false);
    }
    else {
        cntxtmnu.setAttribute('hidden', true);
    }
}

function cntrySfxsInit()
{
    for (var i = 0; document.getElementById("bundle_yellowmapbar").getString("ymb.country." + i) != "endoflist"; i++) {
        cntrySfxs[i] = document.getElementById("bundle_yellowmapbar").getString("ymb.country." + i);
    }
}

function ymbSelectLocaleCountry(cntry)
{
    if (cntry) {
        ymbPref.setIntPref("country2Search", cntry);
        ymbcntry2SrchIx = cntry;
        ymbLocaleCountry = cntrySfxs[ymbcntry2SrchIx];
    }
    else {
        alert(document.getElementById("bundle_yellowmapbar").getString("ymb.country.none"));
    }
}

function setMaxHistCnt(cnt)
{
    if (cnt) {
        ymbPref.setIntPref("maxHistCnt", cnt);
    }
    else {
        alert(document.getElementById("bundle_yellowmapbar").getString("ymb.error.max_hist"));
        ymbPref.setIntPref("maxHistCnt", 10);
    }
    maxHistCnt = ymbPref.getIntPref("maxHistCnt");
}

function yellowmapbarOpenPrefs()
{
	window.openDialog('chrome://yellowmapbar/content/yellowmapbarPrefDialog.xul', 'YellowMapBar Einstellungen', 'chrome');
}

function yellowmapbarOpenYellowMapPrefs()
{
    window._content.document.location = 'http://www.yellowmap.' + ymbLocaleCountry + '/';
}

function yellowmapbarUpdateParent(event)
{
    if (!saveLastOption) {
        return;
    }

    var menuButton = event.target.parentNode.parentNode;
    var separateButton = document.getElementById(event.target.getAttribute("id") + "-separate");

    menuButton.removeAttribute("oncommand");
    menuButton.setAttribute("oncommand", separateButton.getAttribute("oncommand"));

    menuButton.setAttribute("buttonclass", separateButton.getAttribute("buttonclass"));
    menuButton.setAttribute("buttonlabel", separateButton.getAttribute("buttonlabel"));
    menuButton.setAttribute("class", separateButton.getAttribute("class"));

    if (separateButton.getAttribute("label")) {
        menuButton.setAttribute("label", separateButton.getAttribute("label"));
    }

    if (menuButton.getAttribute("id") == "comp-menu") {
        ymbPref.setCharPref("lastCompSearch", event.target.getAttribute("id"));
    }
    else if (menuButton.getAttribute("id") == "info-menu") {
        ymbPref.setCharPref("lastInfoSearch", event.target.getAttribute("id"));
    }
    else if (menuButton.getAttribute("id") == "spec-menu") {
        ymbPref.setCharPref("lastSpecSearch", event.target.getAttribute("id"));
    }
    else {
        alert(document.getElementById("bundle_yellowmapbar").getString("ymb.yellowmapbarUpdateParent.1") + menuButton.getAttribute("id")); 
    }
}

function updateElementClass(element, position, newClass)
{
    var oldClass = element.getAttribute("class");
    var classes = oldClass.split(" ");
    classes[position] = newClass;
    element.setAttribute("class", classes.join(" "));
}

function yellowmapbarShowPopup(event)
{
    if ((event.target.getAttribute("type") == "menu" || event.target.getAttribute("type") == "menu-button") && event.target.firstChild)
    {
      event.target.firstChild.showPopup();
    }
}

function yellowmapbarUpdateNewWindow() {
  // This method is used to update the current search terms 
  // from another window. This should happen when
  // 1. a new window is opened for the first time (called from
  //    yellowmapbarDisplayCheck()
  // 2. a yellowmap 

  var otherCriteria = null;
  var thisCriteria = document.getElementById("yellowmapbarCriteria");

  // If this window was opened from another window, just use
  // the criteria from the opener
  if (window.opener) {
    if (!openerUpdated) {
      otherCriteria = window.opener.document.getElementById("yellowmapbarCriteria");
        if(otherCriteria){
          thisCriteria.value = otherCriteria.value;
          openerUpdated = true;
        }
    }
  }
  else {
    // window had not opener, so get the criteria from somewhere else
    const MEDIATOR_CONTRACTID = "@mozilla.org/appshell/window-mediator;1";
    const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
    var windowManager = 
      Components.classes[MEDIATOR_CONTRACTID].getService(nsIWindowMediator);
    
    var openwindows = windowManager.getEnumerator(null);
    var win=null;
    
    // check all open windows for yellowmapbarCriteria
    // this will always get the search terms of the last window
    // in the list, this might not be the last window which was
    // selected, so this might not always give the expected result
    // (but who needs multiple windows anyway when you have tabs?)
    while (openwindows.hasMoreElements()) {
      win = openwindows.getNext();

      if (win != window) {
        otherCriteria = win.document.getElementById("yellowmapbarCriteria");
        if (win.document.getElementById("yellowmapbarCriteria") != null)
        {
          otherCriteria = win.document.getElementById("yellowmapbarCriteria");
        }
      }
    }
  }

/*
	// This needs a FIX ME!!!
	if (otherCriteria && thisCriteria) {
    thisCriteria.value = otherCriteria.value;
  }
*/

}

function check4NewInstall() {

if(gbCheck4BrowserWindows()){

	// We need to know if we are in Firefox now
	// due to the different way the prefs are called
    try {setYellowMapContextMenu();}
    catch(e) {inFirebird = true;}

// Look for a zero byte file - yellowmapbarIsNew
// This file is only needed if someone changes or adds prefs
// It puts the responsibility on the user for prefs that point to old
// meanings. Unless someone want to make a versioned table of prefs :)

const kDirServiceCID = Components.ID("{f00152d0-b40b-11d3-8c9c-000064657374}");
const nsIProperties = Components.interfaces.nsIProperties;
const nsIFileIID = Components.ID("{c8c0a080-0868-11d3-915f-d9d889d48e3c}");

var cTyp = retv = 0;
var dSrv = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
dSrv = dSrv.QueryInterface(Components.interfaces.nsIProperties);


	var dSrvI = dSrv.get("AChrom", Components.interfaces.nsIFile);
	
	dSrvI.append("yellowmapbar");
	dSrvI.append("content");
	dSrvI.append("yellowmapbarIsNew");
	retv=dSrvI.exists();
	if(retv) {
          cTyp ="AChrom";
        } 
        else {
          dSrvI = dSrv.get("UChrm", Components.interfaces.nsIFile);
          dSrvI.append("yellowmapbar");
          dSrvI.append("content");
          dSrvI.append("yellowmapbarIsNew");
          retv=dSrvI.exists();
          if(retv)
            cTyp ="UChrm";
        }

	if(!cTyp){
		// dump("yellowmapbarIsNew NOT Found in any chrome location\n");
		// Here we can set a pref that is really a flag
		// that then works for every tab and window.
		// that we have checked for any new installation.
		return;
		}
		
	// returns our c:\\windows\stuff as file:///c:/windows
	// not used yet, but it may be later
	// var thisUri = getFileUri(dSrvI);

if(cTyp=="UChrm"){
	dump("Found yellowmapbarIsNew in user profile\n");
		// Tell the user to check their preferences,
		// because they are probably there but have changed meaning.
	if(confirm(document.getElementById("bundle_yellowmapbar").getString("ymb.check4NewInstall.1") )) {
		yellowmapbarOpenPrefs();
		// delete the triggerfile
		dSrvI.remove(true) ;
	}
	else
	if(!confirm(document.getElementById("bundle_yellowmapbar").getString("ymb.check4NewInstall.2") )) {
		// delet the triggerfile
		dSrvI.remove(true) ;
		}

	} //if(cTyp=="UChrm")

if(cTyp=="AChrom"){
	dump("Found yellowmapbarIsNew in system profile\n");
	// Tell the user to check their preferences,
	// because they are probably there but have changed meaning.
		if(confirm(document.getElementById("bundle_yellowmapbar").getString("ymb.check4NewInstall.1") )) {
			yellowmapbarOpenPrefs();
			// delete the triggerfile
			dSrvI.remove(true) ;
	}
	else
	if(!confirm(document.getElementById("bundle_yellowmapbar").getString("ymb.check4NewInstall.2") )) {
		// delet the triggerfile
		dSrvI.remove(true) ;
		}

	}//if(cTyp=="AChrom")

  }// if we have a browser window...

}


function getFileUri( fpath ){
const nsIFileIID = Components.ID("{c8c0a080-0868-11d3-915f-d9d889d48e3c}");
var ios = Components.classes["@mozilla.org/network/io-service;1"]
    	.getService(Components.interfaces.nsIIOService);

    // Interface change - ns7 (mozilla 1.0) needs nsIIOService
    // latter (mozilla 1.2) needs nsIFileProtocolHandler
    if(Components.interfaces.nsIFileProtocolHandler){
      var fileHandler =
      ios.getProtocolHandler("file")
      .QueryInterface(Components.interfaces.nsIFileProtocolHandler);  
      var newUri = fileHandler.getURLSpecFromFile(fpath);
    } else {
      var newUri = ios.getURLSpecFromFile(fpath);
    }
    
return newUri;
}



function gbCheck4BrowserWindows() {

const MEDIATOR_CONTRACTID = "@mozilla.org/appshell/window-mediator;1";
const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
var windowManager = Components.classes[MEDIATOR_CONTRACTID].getService(nsIWindowMediator);

// Quicklaunch seems to be a full browser window.

    if(windowManager.getMostRecentWindow("navigator:browser"))
    {
      if ("arguments" in window && window.arguments.length > 1 && window.arguments[1])
      {
        if (window.arguments[1].indexOf("charset=") != -1)
        {
          var arrayArgComponents = window.arguments[1].split("=");
          if (arrayArgComponents)
          {
            getMarkupDocumentViewer().defaultCharacterSet = arrayArgComponents[1];
          }
        }
        else
        if (window.arguments[1].indexOf("turbo=yes") != -1)
        {
          var gb_turboMode = true;
          return false ;
        }

	} // got a browser window besides quicklaunch
   	return true ;
   	
  } // no browsers
  return false;
}


function yellowmapbarIsUnHiding(){
	var yellowmapbar = document.getElementById( "yellowmapbar" );
	var currCrit = document.getElementById("yellowmapbarCriteria").value ;
	// If you have some text in the criteria box, updating searchword buttons
	// on reappearance is unsightly. The buttons adjust one character at a time.

	if(yellowmapbar.getAttribute("hidden") == "false")
		return;

	yellowmapbarClearCrit();
	yellowmapbarClearTerms();
	goToggleToolbar("yellowmapbar","cmd_yellowmapbarShowHide");
	setTimeout("document.getElementById('yellowmapbarCriteria').focus()", 100);

	// let's just blank it out... for now.
	currCrit = "";
	document.getElementById("yellowmapbarCriteria").value = currCrit ;
	yellowmapbarAddTerm(currCrit);
	}

function yellowmapbarIsHiding(){
var yellowmapbar = document.getElementById( "yellowmapbar" );

	if(yellowmapbar.getAttribute("hidden") == "true")
		return;

	goToggleToolbar('yellowmapbar','cmd_yellowmapbarShowHide');
	setTimeout("document.getElementById('urlbar').focus()", 0);
	}

function gbDoNonSearch(event, searchType, searchParams) {
// a place to do non YellowMap searches explicitly
// return true if we find anything we can handle, whether we actually do anything
// with it is not relevant, just whether we should keep going through the main search
// processing
	
	if( searchType == 'gb-prefill' )	{

		if(inFirebird) {
		alert(document.getElementById("bundle_yellowmapbar").getString("ymb.gbDoNonSearch.1"));		
//		return true; // nothing for now but a msg
		}

		var gbformsArray = content.document.forms;
		if ( !gbformsArray ) {
			return true ;
		}
		
	    if (event.button == 1) {
		var gbwallet = Components.classes["@mozilla.org/wallet/wallet-service;1"].getService(Components.interfaces.nsIWalletService);
			gbwallet.WALLET_RequestToCapture( window._content );
		}

		else {
		if( event.ctrlKey || event.shiftKey || event.altKey ) {
			formPrefill();
			// any modifier key bring up the forms dialog if an unknown form,
			// known forms it will fill in if you told it to do so previously
			// do we want to touch passwords and the security issues.
		}
		else
		var walletService = Components.classes["@mozilla.org/wallet/wallet-service;1"].getService(Components.interfaces.nsIWalletService);
			try { walletService.WALLET_Prefill(true, window._content); }
			catch(e) { } 
		}

		return true;
	}

	return false; // we found nothing to handle here, keep going with main yellowmapbarSearch
}

function ymbParseAddressToUri(address)
{
	var RegexAddressSplit = /^\s*([A-Z]*\s*[- ]\s*)?(\d\d\d\d+)?\s*(.*)\s*$/;
	RegexAddressSplit.exec(address);

	var searchUri;
	var Country = TrimString(RegExp.$1);
	var Zip = TrimString(RegExp.$2);
	var Town = TrimString(RegExp.$3);
	var Street = "";

	// Versuche Strasse abzusplitten (alles nach letztem Komma)
	var CommaIdx = Town.lastIndexOf(",");
	if (CommaIdx != -1)
	{
		Street = TrimString(Town.substring(CommaIdx+1, Town.length));
		Town = TrimString(Town.substring(0, CommaIdx));
	}

	searchUri = "Country=" + ymbBuildUri(Country);
	searchUri += "&Zip=" + ymbBuildUri(Zip);
	searchUri += "&Town=" + ymbBuildUri(Town);
	searchUri += "&Street=" + ymbBuildUri(Street);
	return searchUri
}

function ymbLook4URL(event, searchType, searchParams)
{
    var criteria = document.getElementById("yellowmapbarCriteria");
	var testIndx;
	var tempval  = criteria.value;


    try { testIndx = tempval.search(/^(http|https|ftp|file|irc|mailto|news|nntp):/i); }
	    catch(e)
	    	{
	    	testIndx = -1;
	    } // nothing

	if(testIndx != -1)
		return 1;
	else
    try { testIndx = tempval.search(/^(www\.)/i); }
	    catch(e)
	    	{ /* XXX replace the prefix to http://  */
	    	testIndx = -1;
	   	} 
	    
	if(testIndx != -1) {
    	var newval = "http://" + criteria.value;
    	criteria.value = newval;
		return 1;
	}
	else
		return 0;
		// we didn't find it, or there was a general error
		
}

function ymbLook4Address(event, searchType, searchParams)
{
    var criteria = document.getElementById("yellowmapbarCriteria");
	var testIndx;
	var tempval  = criteria.value;

	// Test, ob der Suchstring eine Addresse ist
	// Hat Plz oder "Loc:" ?
    try 
	{
		testIndx = tempval.search(/^\s*(Loc:|[A-Z]*-?[0-9][0-9][0-9][0-9])/i); 
	}
	catch(e)
	{
		testIndx = -1;
	} 

	if(testIndx != -1)
		return 1;
	else
		return 0;
}



function gbprompt(msg, initial, parent, title)
{	 
     var PROMPT_CTRID = "@mozilla.org/embedcomp/prompt-service;1";
     var nsIPromptService = Components.interfaces.nsIPromptService;
     var ps = Components.classes[PROMPT_CTRID].getService(nsIPromptService);
     if (!parent)
         parent = window;
     if (!title)
         title = MSG_PROMPT; // probably just in seamonkey
     rv = { value: initial };
 
     if (!ps.prompt (parent, title, msg, rv, null, {value: null}))
         return null;
 
     return rv.value;
}

